Subject: [trill] my thoughts ->Re: draft-ietf-trill-directory-assist-mechanisms-02 - 2 week WG (5/29 to 6/12)

From: gayle noble <[email-masked]>
Date: Wed, 03 Jun 2015 16:39:49 -0700

TRILL: Edge Directory Assist Mechanisms
         <draft-ietf-trill-directory-assist-mechanisms-02.txt>

corrections::

1.   page 7 first complete sentence on this page
["Push Directories" should be "Push Directory servers" and "copies of 
the directory that will be pushed." doesn't make sense in the context 
of the rest of the sentence.]
(as written)
If the Push Directories for a Data Label are configured consistently 
with the same N and at least N servers are available, then N copies 
of the directory that will be pushed.
(maybe should be ??)
If the Push Directory servers for a Data Label are configured 
consistently with the  same N and at least N servers are available, 
then N copies of that directory will be pushed.
-----------------------------------------------------

2.   page 7 second paragraph second sentence
[This sentence has a period after "APPsub-TLV." which is followed by 
a trailing part of the sentence after the period which seems to be a 
repeat of the information before "APPsub-TLV."]
(as written)
This priority is treated as an unsigned integer where larger 
magnitude means higher priority and is in its ESADI Parameter 
APPsub-TLV. means higher priority.
(should probably be written by breaking into two sentences)
This priority is treated as an unsigned integer where larger 
magnitude means higher priority. This priority appears in its ESADI 
Parameter APPsub-TLV.
-------------------------------

3.   page 8 first paragraph second sentence
["and representing the state" does not make sense. Should this be 
"and "represents the state" ?]
(as written)
The name of each state is followed by a symbol that starts and ends 
with an angel bracket and representing the state.
(should be???)
The name of each state is followed by a symbol that starts and ends 
with an angel bracket and represents the state.
---------------------------------------
4.   page 8 last paragraph
[This needs a few commas around "that the directory is no longer 
complete"  and "stop" should be "stops"]
(as written)
Going Stand-By <S6>: The same behavior as Active except that it
      responds differently to events. The purpose of this state is to be
      sure that the information that the directory is no longer complete
      has enough time to propagate to edge TRILL switches before the
      Directory Server stop advertising updates to the information.
(should be)
Going Stand-By <S6>: The same behavior as Active except that it
      responds differently to events. The purpose of this state is to be
      sure that the information, that the directory is no longer complete,
      has enough time to propagate to edge TRILL switches before the
      Directory Server stops advertising updates to the information.
----------------------------------------------------------------------------

5.   page 9 first paragraph second sentence
[A few commas around "that the directory is no longer complete" needed]
(as written)
The purpose of this state is to be sure that the information that the 
directory is no longer complete has enough time to propagate to edge 
TRILL switches before the Directory Server might stop advertising 
updates to the information.
(I'd write)
The purpose of this state is to be sure that the information, that 
the directory is no longer complete, has enough time to propagate to 
edge TRILL switches before the Directory Server might stop 
advertising updates to the information.
----------------------------------------------------------------------------------

6.   page 10 First paragraph second sentence
["data reachable" repeated twice]
(as written)
This is determined by the server finding that it is priority K among 
the data reachable data reachable Push Directory servers (where 
highest priority is 1), it is configured that there should be N 
copies pushed, and K is greater than N.
(should be)
This is determined by the server finding that it is priority K among 
the data reachable Push Directory servers (where highest priority is 
1), it is configured that there should be N copies pushed, and K is 
greater than N.
-------------------------------------------------------------

7.   page 12 first paragraph
["for" should be "from"]
(as written)
Push Directory mappings can be distinguished for other data 
distributed through ESADI because mappings are distributed only with 
the Interface Addresses APPsub-TLV [IA] and are flagged in that 
APPsub-TLV as being Push Directory data.
(should be)
Push Directory mappings can be distinguished from other data 
distributed through ESADI because mappings are distributed only with 
the Interface Addresses APPsub-TLV [IA] and are flagged in that 
APPsub-TLV as being Push Directory data.
--------------------------------------------------------------------

8.   page 12 sixth paragraph
["have" should be "has" as it is referring to a single switch]
(as written)
Condition 2 is necessary because a client TRILL switch might be just 
coming up and receive an EASDI LSP meeting the requirement in 
condition 1 above but have not yet received all of the ESADI LSP 
fragment from the Push Directory server.
(should be)
Condition 2 is necessary because a client TRILL switch might be just 
coming up and receive an EASDI LSP meeting the requirement in 
condition 1 above but has not yet received all of the ESADI LSP 
fragment from the Push Directory server.
----------------------------------------------------------------------------

9.   page 13 last paragraph last sentence
["alreayd" should be spelt "already"]
(as written)
Because the data from a secondary server will necessarily be at least 
a little less fresh than that from a primary server, it is 
RECOMMENDED that the re-  originated secondary server data be given a 
confidence level of one less than that of the data as received from 
the primary (or unchanged if it is alreayd of minimum confidence).
(should be)
(as written)
Because the data from a secondary server will necessarily be at least 
a little less fresh than that from a primary server, it is 
RECOMMENDED that the re-  originated secondary server data be given a 
confidence level of one less than that of the data as received from 
the primary (or unchanged if it is already of minimum confidence).
----------------------------------------------------------------------------

10. page 14 third paragraph last sentence
["Errors returns can be sent" should either be "Error returns" or 
"Errors returned" and "Errors can be returned" reads a whole lot better]
(as written)
Errors returns can be sent for queries or updates as described in Section 3.5.
(I think it should be)
Errors can be returned for queries or updates as described in Section 3.5."
--------------------------------------------------------------------------------

11. page 15  Flags: second sentence
["Flags" is plural "is" is singular. So "is" should be "are" and 
"meaning" should be "meanings"]
(as written)
Flags whose meaning is not specified are reserved, MUST be sent as 
zero, and MUST be ignored on receipt.
(should be)
Flags whose meanings are not specified are reserved, MUST be sent as 
zero, and MUST be ignored on receipt.
-----------------------------------------------------------------------------------

12. Page 16 Sequence Number first sentence
["opaque" means "impervious to light, so that images cannot be seen 
through it" I think what is wanted is "identifying" defined in RFC 791]
(as written)
An opaque 32-bit quantity set by the TRILL switch sending a request 
or other unsolicited message and returned in every corresponding 
reply or acknowledgement.
(probably should be)
An identifying 32-bit quantity set by the TRILL switch sending a 
request or other unsolicited message and returned in every 
corresponding reply or acknowledgement.
--------------------------------------------------------

13. Page 18 second to the last sentence
["sent" is past tense. "sentence is in present tense. So it should be ""send"]
(as written)
If a TRILL switch is not capable of handling partial responses to 
queries with multiple QUERY Records, it MUST NOT sent a Request 
Message with more than one QUERY Record in it.
(should be)
If a TRILL switch is not capable of handling partial responses to 
queries with multiple QUERY Records, it MUST NOT send a Request 
Message with more than one QUERY Record in it.
-------------------------------------------------------------------------------------

14. page 19 first sentence
["Message result" I think it should be "Message results"]
(as written)
A Pull Directory Query Message result in a Pull Directory Response 
Message as described in Section 3.2.2.1.
(I think it should be)
A Pull Directory Query Message results in a Pull Directory Response 
Message as described in Section 3.2.2.1.
------------------------------------------------------------------------------
15. page 22  RARP:  second sentence
[I'd add the words "as described" before "above" or omit "above"]
(as written)
If the ar$op field is ares_op$REQUEST, the frame is handled as an ARP above.
(I'd write)
If the ar$op field is ares_op$REQUEST, the frame is handled as an ARP 
as described above.

---------------------------------------------------------------------

16. page 22 last sentence
[This sentence is missing a comma and also missing some words to make 
the end make sense.
First thought:: "there may still be brief periods of time when 
directory information has changed"
second thought:: "but cached information a pull clients has"
third thought not complete:: "not yet been updated or expunged."
It is like the "has" from the end of the second thought, is being 
auto reused???  Also "clients" is plural but "a" refers to a 
singular. What if I rephrase this ???? :::]
(as written)
In all cases, there may still be brief periods of time when directory 
information has changed but cached information a pull clients has not 
yet been updated or expunged.
(I'd write)
In all cases, there may still be brief periods of time when directory 
information has changed, but information a pull client has cached has 
not yet been updated or expunged.
----------------------------------------------------------------------------------
17. page 25 section 3.3.1. Update Message Format first sentence
["Message with the with differences" an extra "with"]
(as written)
An Update Message is formatted as a Response Message with the with
   differences described in Section 3.3 above and the following:
(should be)
An Update Message is formatted as a Response Message with the 
differences described in Section 3.3 above and the following:
------------------------------------------------------------------------

18.   page 32 second paragraph second sentence
[ Add comma after "That is" and "Lable" should be "Label"]
(as written)
That is the Push Model is used for some Data Labels or addresses 
within a Data Lable while the Pull Model is used for other Data 
Labels or addresses within a Data Label.
(should be)
That is, the Push Model is used for some Data Labels or addresses 
within a Data Label while the Pull Model is used for other Data 
Labels or addresses within a Data Label.
-------------------------------------------------------------------------------------

19. page 32 third paragraph third sentence
["for management interface" reads real rough. It says thee is one 
interface "management interface" which is not what I think is meant. 
It would read smoother if "interface" was "interfacing" which covers 
any management stuff done]
(as written)
For hosts in other Data Labels that only communicate with external 
peers occasionally for management interface, the mapping entries for 
those VLANs should be pulled down from directory when the need comes up.
(I'd write)
For hosts in other Data Labels that only communicate with external 
peers occasionally for management interfacing, the mapping entries 
for those VLANs should be pulled down from directory when the need comes up.
----------------------------------------------------------------------------

20. page 35   6.1 ESADI-Parameter Data Extensions first sentence
["assigned" is past tense. I think this is a request to have it 
assigned so it should be present tense]
(as written)
Action 1: IANA will assigned a two bit field [bits 1-2 suggested] 
within the ESADI-Parameter TRILL APPsub-TLV flags for "Push Directory 
Server Status" (PDSS) and will create a sub-registry in the TRILL 
Parameters Registry as follows:
(should be)
Action 1: IANA will assign a two bit field [bits 1-2 suggested] 
within the ESADI-Parameter TRILL APPsub-TLV flags for "Push Directory 
Server Status" (PDSS) and will create a sub-registry in the TRILL 
Parameters Registry as follows:
-----------------------------------------------------------------------------------

Confusion

1.      page 28/29 description of error fields
The text states:
ERR values 1 through 126 are available for encoding Request or Update 
Message level errors.
ERR values 128 through 254 are available for encoding QUERY or 
RESPONSE Record level errors
Then the fields are noted
(as written)
       Err    Meaning
      -----   -------
          0    (no error)

          1     Unknown or reserved Query Message field value
          2    Request Message/data too short
          3    Unknown or reserved Update Message field value
          4    Update Message/data too short
      5-126    (Available for allocation by IETF Review)
        127    Reserved

        128    Unknown or reserved QUERY Record field value
        129    QUERY Record truncated
        130    Address not found
        131    Unknown or reserved RESPONSE Record field value
        132    RESPONSE Record truncated
      133-254  (Available for allocation by IETF Review)
        255    Reserved
Just be aware this is VERY confusing as one who is not a guru at this 
would think it would be::
       Err    Meaning
      -----   -------
          0    (no error)

         1     Unknown or reserved Request Message field value
          2    Request Message/data too short
          3    Unknown or reserved Update Message field value
          4    Update Message/data too short
      5-126    (Available for allocation by IETF Review)
        127    Reserved

        128    Unknown or reserved QUERY Record field value
        129    QUERY Record truncated
        130    Address not found
        131    Unknown or reserved RESPONSE Record field value
        132    RESPONSE Record truncated
      133-254  (Available for allocation by IETF Review)
        255    Reserved

===============
total confusion::

2.   page 7 second paragraph second sentence
A sentence is written
"This priority is treated as an unsigned integer where larger 
magnitude means higher priority"
Based on everything I can find, " larger magnitude", means larger 
number. Thus 2 is a larger magnitude then 1.
However in paragraph 3 the third sentence it says :
"If a Push Directory server is configured to believe that N copies of 
the mappings for a Data Label should be pushed and finds that it is 
number K in the priority ordering (where number 1 is highest priority 
and number K is lowest), then if K is less than or equal to N the 
Push Directory server is Active. If K is greater than N it is Stand-By."

(It would be less confusing to us nubies if written)
"If a Push Directory server is configured to believe that N copies of 
the mappings for a Data Label should be pushed and finds that it is 
Kth in the priority ordering (where the first is highest priority and 
the last is lowest), then if K is less than or equal to N the Push 
Directory server is Active. If K is greater than N it is Stand-By."

-----------------------------------------------------

---

From: Donald Eastlake <[email-masked]>
Date: Mon, 8 Jun 2015 21:27:35 -0400

Hi Gayle,

Thanks for your corrections and questions. I'm fine with your suggested
changes 1-20.

The existence of both the "Query Message" and the "QUERY Record" data
structures is a bit confusing. The Query Message contains from zero to 15
QUERY Records. I'll think about the best way to clarify this.

And I think your suggested wording change in reference to priority ordering
of Push Directory servers is good.

Thanks,
Donald
=============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 155 Beaver Street, Milford, MA 01757 USA
 [email-masked]

On Wed, Jun 3, 2015 at 7:39 PM, gayle noble <[email-masked]> wrote:

> ["Push Directories" should be "Push Directory servers" and "copies of the
> directory that will be pushed." doesn't make sense in the context of the
> rest of the sentence.]
> (as written)
> If the Push Directories for a Data Label are configured consistently with
> the same N and at least N servers are available, then N copies of the
> directory that will be pushed.
> (maybe should be ??)
> consistently with the  same N and at least N servers are available, then N copies
> of that directory will be pushed.
> [This sentence has a period after "APPsub-TLV." which is followed by a
> trailing part of the sentence after the period which seems to be a repeat
> of the information before "APPsub-TLV."]
> (as written)
> This priority is treated as an unsigned integer where larger magnitude
> means higher priority and is in its ESADI Parameter APPsub-TLV. means
> higher priority.
> This priority is treated as an unsigned integer where larger magnitude
> means higher priority. This priority appears in its ESADI Parameter
> APPsub-TLV.
> ["and representing the state" does not make sense. Should this be "and
> "represents the state" ?]
> (as written)
> The name of each state is followed by a symbol that starts and ends with
> an angel bracket and representing the state.
> (should be???)
> The name of each state is followed by a symbol that starts and ends with
> an angel bracket and represents the state.
> TRILL switches before the Directory Server might stop advertising updates
> to the information.
> (I'd write)
> The purpose of this state is to be sure that the information, that the
> directory is no longer complete, has enough time to propagate to edge
> TRILL switches before the Directory Server might stop advertising updates
> to the information.
>
> This is determined by the server finding that it is priority K among the data
> reachable data reachable Push Directory servers (where highest priority
> is 1), it is configured that there should be N copies pushed, and K is
> greater than N.
> (should be)
> This is determined by the server finding that it is priority K among the data
> reachable Push Directory servers (where highest priority is 1), it is
> configured that there should be N copies pushed, and K is greater than N.
> Push Directory mappings can be distinguished for other data distributed
> through ESADI because mappings are distributed only with the Interface
> Addresses APPsub-TLV [IA] and are flagged in that APPsub-TLV as being Push
> Directory data.
> (should be)
> Push Directory mappings can be distinguished from other data distributed
> through ESADI because mappings are distributed only with the Interface
> Addresses APPsub-TLV [IA] and are flagged in that APPsub-TLV as being Push
> Directory data.
> coming up and receive an EASDI LSP meeting the requirement in condition 1
> above but have not yet received all of the ESADI LSP fragment from the
> Push Directory server.
> (should be)
> coming up and receive an EASDI LSP meeting the requirement in condition 1
> above but has not yet received all of the ESADI LSP fragment from the
> Push Directory server.
>
> Because the data from a secondary server will necessarily be at least a
> little less fresh than that from a primary server, it is RECOMMENDED that
> the re-  originated secondary server data be given a confidence level of
> one less than that of the data as received from the primary (or unchanged
> if it is alreayd of minimum confidence).
> (should be)
> (as written)
> Because the data from a secondary server will necessarily be at least a
> little less fresh than that from a primary server, it is RECOMMENDED that
> the re-  originated secondary server data be given a confidence level of
> one less than that of the data as received from the primary (or unchanged
> if it is already of minimum confidence).
>
> ["Errors returns can be sent" should either be "Error returns" or "Errors
> returned" and "Errors can be returned" reads a whole lot better]
> (as written)
> Errors can be returned for queries or updates as described in Section
> 3.5.”
>
> ["Flags" is plural "is" is singular. So "is" should be "are" and "meaning"
> should be "meanings"]
> (as written)
> Flags whose meaning is not specified are reserved, MUST be sent as zero,
> and MUST be ignored on receipt.
> (should be)
> through it" I think what is wanted is "*identifying*" defined in RFC 791]
> (as written)
> An opaque 32-bit quantity set by the TRILL switch sending a request or
> other unsolicited message and returned in every corresponding reply or
> acknowledgement.
> (probably should be)
> An *identifying* 32-bit quantity set by the TRILL switch sending a
> request or other unsolicited message and returned in every corresponding
> If a TRILL switch is not capable of handling partial responses to queries
> with multiple QUERY Records, it MUST NOT sent a Request Message with more
> than one QUERY Record in it.
> (should be)
> If a TRILL switch is not capable of handling partial responses to queries
> with multiple QUERY Records, it MUST NOT send a Request Message with more
> than one QUERY Record in it.
>
> above.
> If the ar$op field is ares_op$REQUEST, the frame is handled as an ARP as
> described above.
>
> [This sentence is missing a comma and also missing some words to make the
> end make sense.
> First thought:: "there may still be brief periods of time when directory
> information has changed"
> It is like the "has" from the end of the second thought, is being auto
> reused???  Also "clients" is plural but "a" refers to a singular. What if I
> rephrase this ???? :::]
> (as written)
> information has changed but cached information a pull clients has not yet been
> updated or expunged.
> (I'd write)
> information has changed, but information a pull client has cached has not
> An Update Message is formatted as a Response Message with the differences
> described in Section 3.3 above and the following:
> That is the Push Model is used for some Data Labels or addresses within a
> Data Lable while the Pull Model is used for other Data Labels or
> addresses within a Data Label.
> (should be)
> That is, the Push Model is used for some Data Labels or addresses within
> a Data Label while the Pull Model is used for other Data Labels or
> addresses within a Data Label.
>
> interface "management interface" which is not what I think is meant. It
> would read smoother if "interface" was "interfacing" which covers any
> management stuff done]
> (as written)
> For hosts in other Data Labels that only communicate with external peers
> occasionally for management interface, the mapping entries for those
> VLANs should be pulled down from directory when the need comes up.
> (I'd write)
> For hosts in other Data Labels that only communicate with external peers
> occasionally for management interfacing, the mapping entries for those
> VLANs should be pulled down from directory when the need comes up.
>
> ["assigned" is past tense. I think this is a request to have it assigned
> so it should be present tense]
> (as written)
> Action 1: IANA will assigned a two bit field [bits 1-2 suggested] within
> the ESADI-Parameter TRILL APPsub-TLV flags for "Push Directory Server
> Status" (PDSS) and will create a sub-registry in the TRILL Parameters
> Registry as follows:
> (should be)
> Action 1: IANA will assign a two bit field [bits 1-2 suggested] within
> the ESADI-Parameter TRILL APPsub-TLV flags for "Push Directory Server
> Status" (PDSS) and will create a sub-registry in the TRILL Parameters
> Registry as follows:
>
> ERR values 128 through 254 are available for encoding QUERY or RESPONSE
> Record level errors
> "This priority is treated as an unsigned integer where larger magnitude
> means higher priority"
> Based on everything I can find, " larger magnitude", means larger number.
> Thus 2 is a larger magnitude then 1.
> "If a Push Directory server is configured to believe that N copies of the
> mappings for a Data Label should be pushed and finds that it is number K in
> the priority ordering (where number 1 is highest priority and number K is
> lowest), then if K is less than or equal to N the Push Directory server
> is Active. If K is greater than N it is Stand-By."
>
> “If a Push Directory server is configured to believe that N copies of the
> mappings for a Data Label should be pushed and finds that it is Kth in the
> priority ordering (where the first is highest priority and the last is
> lowest), then if K is less than or equal to N the Push Directory server
> is Active. If K is greater than N it is Stand-By."
>
>
> _______________________________________________
> trill mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/trill
>
>

---

From: Donald Eastlake <[email-masked]>
Date: Thu, 11 Jun 2015 14:41:23 -0400

I support this draft as a good basis for ARP/ND optimization and reducing
unknown unicast flooding as well as detection of forged source addresses.

I am not aware of any IPR other than that which has already been disclosed.

Looking at the overall draft, in the Pull Directory section, there are four
different message types. While these all have a common header, the
remainder of the message can be various different things, commonly zero or
more instances of a record structure. Exactly what the remainder of the
message is can depend on whether the error field in the header is zero or
non-zero or on flags in the header. While I do not think there is any
technical problem here, I believe a table and section summarizing the
different cases would add clarity to the draft. (In addition, the typos and
clarifications pointed out by Gayle Noble should be incorporated.)

Thanks,
Donald

On Fri, May 29, 2015 at 8:10 AM, Susan Hares <[email-masked]> wrote:

> This is to begin a 2 week WG LC on the draft:
> draft-ietf-trill-directory-assist-mechanisms-02 (5/29 to 6/12).  You can
> find the draft at:
>
>
>
>
> http://datatracker.ietf.org/doc/draft-ietf-trill-directory-assist-mechanisms/
>
>
>
> There are 3 IPR statements
>
>
>
>
> https://datatracker.ietf.org/ipr/search/?submit=draft&id=draft-ietf-trill-directory-assist-mechanisms
>
>
>
> The authors (Donald, Linda, Radia, Igor, Yizhou) should indicate if they
> know if any additional IPR.
>
>
>
> A summary of the document is:
>
>
>
>   This document describes mechanisms for providing directory service to
>
>    TRILL (Transparent Interconnection of Lots of Links) edge switches.
>
>    The directory information provided can be used in reducing multi-
>
>    destination traffic, particularly ARP/ND and unknown unicast
>
>    flooding. It can also be used to detect traffic with forged source
>
>    addresses.
>
>
>
> One of our main objects for 2015 is to complete the directory services
> work.  Please answer a few questions
>
>
>
> 1)      Do you consider this draft for IESG publishing?
>
> 2)      Does the IPR cause you any concerns in agreeing to publish this
> as an TRILL standard?
>
> 3)      Does it provide necessary directory services for better
> deployment of TRILL?
>
> 4)      Are there any technical problems?
>
>
>
> Sue Hares and Jon Hudson
>

---

From: Liyizhou <[email-masked]>
Date: Mon, 15 Jun 2015 01:13:42 +0000

I donot know any additional IPR about this document.

Thanks,
Yizhou

From: trill [mailto:[email-masked]] On Behalf Of Susan Hares
Sent: Friday, May 29, 2015 8:10 PM
To: [email-masked]
Cc: 'Donald Eastlake'; 'Jon Hudson'
Subject: [trill] draft-ietf-trill-directory-assist-mechanisms-02 - 2 week WG (5/29 to 6/12)

This is to begin a 2 week WG LC on the draft: draft-ietf-trill-directory-assist-mechanisms-02 (5/29 to 6/12).  You can find the draft at:

The authors (Donald, Linda, Radia, Igor, Yizhou) should indicate if they know if any additional IPR.

One of our main objects for 2015 is to complete the directory services work.  Please answer a few questions

2)      Does the IPR cause you any concerns in agreeing to publish this as an TRILL standard?

3)      Does it provide necessary directory services for better deployment of TRILL?

Sue Hares and Jon Hudson

---

From: Radia Perlman <[email-masked]>
Date: Mon, 15 Jun 2015 20:36:15 -0400

* I do not know of any additional IPR.*

*Radia*